import numpy as np
import matplotlib.pyplot as plt
from PIL import Image
from IPython.display import Image as im
import sys
import re
from wordcloud import WordCloud, STOPWORDS
from twython import Twython


#usar o objeto twitter para pesquisar um query e retornar os tweets obtidos
def get_results(query,
        key="ahKkvexLOjz8sZc3hhPiUUISa",
        secret="kjM4N9VH53CnoxCdZBtAfUvoDyuj9izLi2qoE9t2irYgn5X8ts"):
    print("Starting cursor")
    tweets = {}
    i = 0

    #conectar ao twitter usando o secreto e a chave
    twitter = Twython(key, secret)
    pages = twitter.cursor(twitter.search, q=query, result_type='recent', 
            return_pages=True, count=200, tweet_mode='extended')

    #Cada página tem vários tweets, então esse loop percorre todas e guarda
    #os tweets em um dicionário, onde a chave é o 'id' e o valor é o objeto 
    #do tweet
    try:
        for page in pages:
            try:
                print("page " + str(i))
                for tweet in page:
                    tweets[tweet["id"]] = tweet
                i += 1
                if i > 50: 
                    break
            except StopIteration:
                print("catching StopIteration")
                break
    except StopIteration:
        print("catching stopIteration exception")
    
    print(str(len(tweets)) + " tweets")
    return tweets

#pegar os objetos de tweets retornados pela api e retirar apenas o conteúdo deles, o texto
def get_tweet_text(tweets):
    text = []
    
    for key in tweets:
        t = tweets[key]['full_text'] if 'full_text' in tweets[key] else tweets[key]['text']
        text.append(t)
    return text

#tratar o texto recebido de forma que posa ser passado para a função da biblioteca word cloud
def treat_text(texts, query):
    raw_text = ''.join(texts)
    no_links = re.sub(r'http\S+', '', raw_text)
    no_unicode = re.sub(r"\\[a-z][a-z]?[0-9]+", '', no_links)
    no_special_characters = re.sub('[^A-Za-z ]+', '', no_unicode)

    words = no_special_characters.split(" ")
    #considering we're working in portuguese, is two ok? shouldn't we raise it to three to exclude words like com, sem, tem, por etc?
    words = [w for w in words if len(w) > 3]
    words = [w.lower() for w in words]
    words = [w for w in words if w not in STOPWORDS]
    words = [w for w in words if w not in query]
    return words

#usar o texto de entrada obtido para criar a imagem de wordcloud
def create_word_cloud(content, mask, path, query):
    mask = np.array(Image.open(mask))
 
    wc = WordCloud(background_color="white",max_words=2000, mask=mask)
    clean_string = ','.join(content)
    wordcloud = wc.generate(clean_string)

    f = plt.figure(figsize=(60,60))
    plt.imshow(wordcloud, interpolation='bilinear')
    plt.title('Twitter Search For \''+query+'\'', size=40)
    plt.axis("off")
    plt.show()
    plt.savefig(path)

    return

#Usar a biblioteca sys para pegar os argumentos de linha de comando: query, caminho da imagem e caminho para a máscara
#Uso: python3 tweet_cloud.py <query_word> <output-image_path> <mask-image_path>
#Exemplo: python3 tweet_cloud.py bolo bolo_nuvem.png cloud_mask.png
def get_arguments():
    query = " ".join(sys.argv[1].split("_"))
    output = sys.argv[2]
    mask = sys.argv[3]
    return query, output, mask

def run_api():
    query, output, mask = get_arguments()
    tweets = get_results(query)
    texts = get_tweet_text(tweets)
    words = treat_text(texts, query)
    create_word_cloud(words, mask, output, query)

run_api()
